unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  CDInfo, StdCtrls, ExtCtrls, Buttons, Rptbtn, CDDBConnect, CDDatabase;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Timer1: TTimer;
    TrackLabel: TLabel;
    PosnLabel: TLabel;
    Button5: TButton;
    Button6: TButton;
    RepeatButton1: TRepeatButton;
    RepeatButton2: TRepeatButton;
    Label1: TLabel;
    TrackNameLabel: TLabel;
    CDDBConnect1: TCDDBConnect;
    CDInfo1: TCDInfo;
    CDLabel: TLabel;
    Button7: TButton;
    Button8: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure RepeatButton1Click(Sender: TObject);
    procedure RepeatButton2Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure CDInfo1Eject(Sender: TObject);
    procedure CDInfo1Insert(Sender: TObject);
    procedure Button8Click(Sender: TObject);
  private
    { Private declarations }
    FGotDetails : Boolean;
    FCDEntry : TAccessDBEntry;
    procedure ShowCDMessage(AMessage: string);
    procedure ShowCDDetails;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

uses Unit2;

{$R *.DFM}

const
  CTrack = 'Track ';
  CPosn = 'Position ';
  CNoCD = '[No CD Inserted]';
  CUnknownCD = '[No Information Available]';

procedure TForm1.Button1Click(Sender: TObject);
begin
  CDInfo1.Play;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
	CDInfo1.Pause;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
	CDInfo1.Stop;
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
	CDInfo1.Eject;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
	Timer1.Enabled := False;
  if CDInfo1.Ready then
  begin
    TrackLabel.Caption := CTrack + IntToStr(CDInfo1.CurrentTrack) + ' of ' +
      IntToStr(CDInfo1.TotalTrackCount);
    PosnLabel.Caption := CPosn + CDInfo1.TOCToString(CDInfo1.ElapsedTrackTime);
    if FGotDetails then
      TrackNameLabel.Caption := FCDEntry.Tracks[CDInfo1.CurrentTrack-1];
  end;
  Timer1.Enabled := True;
end;

procedure TForm1.Button5Click(Sender: TObject);
begin
	CDInfo1.Previous;
end;

procedure TForm1.Button6Click(Sender: TObject);
begin
	CDInfo1.Next;
end;

procedure TForm1.RepeatButton1Click(Sender: TObject);
begin
  CDInfo1.SeachForward;
end;

procedure TForm1.RepeatButton2Click(Sender: TObject);
begin
  CDInfo1.SearchBackwards;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  FCDEntry.Free;
end;

procedure TForm1.Button7Click(Sender: TObject);
begin
  CDDatabaseForm.Show;
end;

procedure TForm1.FormShow(Sender: TObject);
begin
	FCDEntry := TAccessDBEntry.Create;

  if CDInfo1.Ready then
    ShowCDDetails
  else
    ShowCDMessage(CNoCD);
end;

procedure TForm1.ShowCDMessage(AMessage : string);
begin
  TrackLabel.Caption := CTrack + AMessage;
  PosnLabel.Caption := CPosn + AMessage;
  TrackNameLabel.Caption := AMessage;
  CDLabel.Caption := AMessage;
end;

procedure TForm1.CDInfo1Eject(Sender: TObject);
begin
  ShowCDMessage(CNoCD);
end;

procedure TForm1.ShowCDDetails;
begin
  FGotDetails := True;
  try
    if FCDEntry.CDID <> CDInfo1.CDDBDiscIDHex then
    begin
      FGotDetails := False;
      if CDDatabaseForm.CDDatabase1.GetRecording(CDInfo1.CDDBDiscIDHex, FCDEntry) then
        FGotDetails := True
      else
      begin
        FGotDetails := CDDBConnect1.GetInfoForCurrentCD(FCDEntry);
        if FGotDetails then
          CDDatabaseForm.CDDatabase1.AddRecording(FCDEntry);
      end;
    end;
  except
  	// just ignore errors
  end;
  if FGotDetails then
  begin
    CDLabel.Caption := FCDEntry.CDTitle + ' / ' + FCDEntry.ArtistTitle;
  end
  else
    ShowCDMessage(CUnknownCD);
end;

procedure TForm1.CDInfo1Insert(Sender: TObject);
begin
  ShowCDDetails;
end;

procedure TForm1.Button8Click(Sender: TObject);
begin
  ShowCDDetails;
end;

end.
