unit Unit2;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  CDDatabase, ComCtrls, StdCtrls;

type
  TCDDatabaseForm = class(TForm)
    CDDatabase1: TCDDatabase;
    ListView1: TListView;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure ListView1DblClick(Sender: TObject);
  private
    { Private declarations }
    procedure RefreshList;
    procedure Edit;
  public
    { Public declarations }
  end;

var
  CDDatabaseForm: TCDDatabaseForm;

implementation

uses
  CDDBConnect;

{$R *.DFM}

procedure TCDDatabaseForm.RefreshList;
var
	Loop : integer;
  LListItem : TListItem;
  LCDEntry : TAccessDBEntry;
begin
	ListView1.Items.BeginUpdate;
  LCDEntry := TAccessDBEntry.Create;
  try
		ListView1.Items.Clear;
		for Loop := 0 to CDDatabase1.RecordingCount-1 do
  	begin
    	CDDatabase1.GetRecording(Loop, LCDEntry);
    	LListItem := ListView1.Items.Add;
    	LListItem.Caption := LCDEntry.CDTitle;
    	LListItem.SubItems.Add(LCDEntry.ArtistTitle);
  	end;
  finally
  	LCDEntry.Free;
    ListView1.Items.EndUpdate;
  end;
end;

procedure TCDDatabaseForm.Button1Click(Sender: TObject);
begin
  CDDatabase1.SaveAsHTML('c:\temp\test.html');
end;

procedure TCDDatabaseForm.Button2Click(Sender: TObject);
begin
  RefreshList;
end;

procedure TCDDatabaseForm.Button3Click(Sender: TObject);
var
	LRecording : TAccessDBEntry;
begin
	LRecording := TAccessDBEntry.Create;
  CDDatabase1.GetRecording(ListView1.Selected.Index, LRecording);
  CDDatabase1.DeleteRecording(LRecording.CDID);
  LRecording.Free;
  RefreshList;
end;

procedure TCDDatabaseForm.Button4Click(Sender: TObject);
begin
	Edit;
end;

procedure TCDDatabaseForm.ListView1DblClick(Sender: TObject);
begin
  Edit;
end;

procedure TCDDatabaseForm.Edit;
var
	LRecording : TAccessDBEntry;
begin
  LRecording := TAccessDBEntry.Create;
  CDDatabase1.GetRecording(ListView1.Selected.Index, LRecording);
  if LRecording.Edit then
  begin
    CDDatabase1.UpdateRecording(LRecording);
  end;
  LRecording.Free;
end;

end.
